﻿<%@ Page Language="vb" Debug="true" %>

<%@ Import Namespace="System.IO"%>
<%@ Import Namespace="Persits.Jpeg"%>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>

        <script runat="server" language="vb">

            Sub Page_Load(sender As Object, e As EventArgs)
                lblStatus.Style.Add("color", "red")
            End Sub

            Sub OnUpload(sender As Object, E As EventArgs)
                lblStatus.Text = ""

                If FileUpload.HasFile Then
                    Try
                        Dim filename As String = Path.GetFileName(FileUpload.FileName)
                        Dim filepath As String = "c:\upload\" + filename
                        FileUpload.SaveAs(filepath)

                        ' Open uploaded image
                        Dim objJpeg As JpegManager = New JpegManager()
                        Dim objImage As JpegImage = objJpeg.OpenImage(filepath)

                        ' Convert it to RGB
                        objImage.ToRGB()

                        ' Open background: picture of a billboard
                        Dim objBillboard As JpegImage = objJpeg.OpenImage(Server.MapPath("billboard.jpg"))

                        ' Obtain UV object
                        Dim objUV As JpegUV = objBillboard.Canvas.UV

                        objUV.XFunc = "0"
                        objUV.YFunc = "u"
                        objUV.ZFunc = "v"
                        objUV.UMin = -2.45592 / 2
                        objUV.UMax = 2.45592 / 2
                        objUV.VMin = -0.81449
                        objUV.VMax = -0.81449 + 1
                        objUV.UStep = 20
                        objUV.VStep = 20
                        objUV.CameraAngle = 29.97892
                        objUV.CameraX = 2.18979
                        objUV.CameraY = 0.00089
                        objUV.CameraZ = -0.09539
                        objUV.RotateCameraAroundAxes(10.32625, 0, 0)
                        objUV.RotateCameraAroundAxes(0, 32.60264, 0)
                        objUV.RotateCameraAroundAxes(0, 0, 55.948)
                        objUV.RotateCamera(1.13119, 0, 0)
                        objUV.RotateCamera(0, 3.65646, 0)
                        objUV.RotateCamera(0, 0, 10.36281)

                        objBillboard.Canvas.DrawImageUV(objImage)

                        Dim strFilename As String = objBillboard.SaveUnique(Server.MapPath("images/perspective.jpg"))
                        OutputImage.ImageUrl = "images/" + strFilename
                    Catch ex As Exception
                        lblStatus.Text = "Failure: " + ex.Message
                    End Try
                End If
            End Sub

        </script>
</head>
<body>
    <form id="form1" runat="server">
        <img src="06_perspective.png" /><br />
        <h4>AspJpeg.NET Live Demo 7: Perspective Projection</h4>
        <p>Place your image on the photograph of a billboard:</p>
        <div style="width: 300pt; padding: 10pt; border: solid 2pt purple">
            <asp:FileUpload ID="FileUpload" runat="server" />
            <asp:Button runat="server" ID="btnUpload" Text="Upload" OnClick="OnUpload" /><br /><br />
            <asp:Label runat="server" ID="lblStatus"  />
        </div>
        <br /><br />
            <asp:image runat="server" id="OutputImage"/>
        <br /><br />
        <a href="demo_perspective.zip"><B>Download the source code for this live demo (C#/VB.NET)</B></a>

    </form>
</body>
</html>
